<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CommonPriceBreakdown2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CommonPriceBreakdown2 extends AbstractStructArrayBase
{
    /**
     * The Discount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CommonPriceBreakdown[]
     */
    public $Discount;
    /**
     * Constructor method for ArrayOfJP_CommonPriceBreakdown2
     * @uses ArrayOfJP_CommonPriceBreakdown2::setDiscount()
     * @param \StructType\JP_CommonPriceBreakdown[] $discount
     */
    public function __construct(array $discount = array())
    {
        $this
            ->setDiscount($discount);
    }
    /**
     * Get Discount value
     * @return \StructType\JP_CommonPriceBreakdown[]|null
     */
    public function getDiscount()
    {
        return $this->Discount;
    }
    /**
     * This method is responsible for validating the values passed to the setDiscount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDiscount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDiscountForArrayConstraintsFromSetDiscount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CommonPriceBreakdown2DiscountItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CommonPriceBreakdown2DiscountItem instanceof \StructType\JP_CommonPriceBreakdown) {
                $invalidValues[] = is_object($arrayOfJP_CommonPriceBreakdown2DiscountItem) ? get_class($arrayOfJP_CommonPriceBreakdown2DiscountItem) : sprintf('%s(%s)', gettype($arrayOfJP_CommonPriceBreakdown2DiscountItem), var_export($arrayOfJP_CommonPriceBreakdown2DiscountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Discount property can only contain items of type \StructType\JP_CommonPriceBreakdown, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Discount value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown[] $discount
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown2
     */
    public function setDiscount(array $discount = array())
    {
        // validation for constraint: array
        if ('' !== ($discountArrayErrorMessage = self::validateDiscountForArrayConstraintsFromSetDiscount($discount))) {
            throw new \InvalidArgumentException($discountArrayErrorMessage, __LINE__);
        }
        $this->Discount = $discount;
        return $this;
    }
    /**
     * Add item to Discount value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CommonPriceBreakdown $item
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown2
     */
    public function addToDiscount(\StructType\JP_CommonPriceBreakdown $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CommonPriceBreakdown) {
            throw new \InvalidArgumentException(sprintf('The Discount property can only contain items of type \StructType\JP_CommonPriceBreakdown, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Discount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CommonPriceBreakdown|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Discount
     */
    public function getAttributeName()
    {
        return 'Discount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CommonPriceBreakdown2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
